<template>
  <v-container>
    <page-title>
      Compañías clientes
    </page-title>
    <page-content class="mt-0">
      <page-content-list-user>
        <template #buttons>
          <data-button class="mr-2 mt-1" button-name="Agregar" icon="mdi-plus-thick" @clicked="handleClick" />
          <data-button class="mr-2 mt-1" button-name="Plantilla" icon="mdi-file-table-outline" />
          <data-button class="mt-1" button-name="Carga masiva" icon="mdi-book-plus-multiple" />
        </template>

        <template #table>
          <search-table
            outline
            table-title="Compañías clientes"
            :headers="headers"
            :items="companies"
            @edited="editClientCompany"
            :itemsPerPage="pageSize"
            :totalItems="totalCompanies"
            :page="page"
            @eventPagination="paginator"
          >
            <div class="text-center">
              <v-pagination
                v-model="page"
                :length="Math.ceil(totalCompanies/pageSize)"
                :total-visible="7"
              ></v-pagination>
            </div>
          </search-table>
        </template>
      </page-content-list-user>
    </page-content>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import DataButton from '~/components/dataTable/dataButton';
import SearchTable from '~/components/supervisor/SearchTable';
import PageTitle from '~/components/PageTitle';

export default {
  name: 'Clientes',
  components: {
    PageTitle,
    DataButton,
    SearchTable,
  },
  data() {
    return {
      search: '',
      headers: [
        { text: 'Razón Social', align: 'start', value: 'name', sortable: false },
        { text: 'RUC', value: 'ruc', sortable: false },
        { text: 'Correo', value: 'email', filterable: false },
      ],
      pageSize: 10,
      page: 1,
      rows: [],
    };
  },
  computed: {
    ...mapState({
      companies: state => state.providercompany['client-company'].clientCompanies,
      totalCompanies: state => state.providercompany['client-company'].totalCompanies,
      loading: state => state.providercompany['client-company'].loading,
    }),
  },
  async mounted() {
    await this.getAllCompanies(parseInt(this.$route.query.p));
  },
  methods: {
    handleClick() {
      this.$router.push('/clientes/nuevo-cliente');
    },

    rowSelected(item, row) {
      // this.$router.push(`/especialistas/editar-especialista/${item.uuid}`);
      this.$router.push(`/clientes/${item.uuid}`);
    },
    ...mapActions({
      getCompanies: 'providercompany/client-company/getClientCompanies',
    }),
    async getAllCompanies(page = 1) {
      if (isNaN(page)) {
        this.page = 1;
      } else {
        this.page = page;
      }
      let params;

      // If doesn't enter query params, set by default first page.
      if (Object.entries(this.$route.query).length === 0) {
        params = { page: this.page - 1, pagesize: this.pageSize /* search: searchI */ };
      } else { // If enter by query params.
        params = { page: this.page - 1, pagesize: this.pageSize, search: this.$route.query.s };
      }
      await this.getCompanies(params);
    },
    editClientCompany(e) {
      this.$router.push(`/clientes/editar-cliente/${e}`);
    },
    async paginator(page) {
      await this.$router.push({ path: '/clientes', query: { p: page } });

      // Update the table, with paginator.
      this.page = page;
      await this.getAllCompanies(page);
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 2rem;
  margin-left: 1rem;
}
</style>
